//==================================================================
// CMAC ȂǂpCritic̃NX
// 
// e3C^COP̂bl`bɌŒ
// 
// 2005.06.11 CMAC
//		cmac.initAtEqualSpaces( max_dim, 2, 1 ); // e2A^COP
// ֏C
// 2005.06.13 ƂwKȂ̂logfileώ@CriticقƂǉwKĂȂ
//		cmac.initAtEqualSpaces( max_dim, 3, 1 ); // e3A^COP 
// ֖߂
//==============================================
import java.lang.Math ;
import java.awt.*;
import java.awt.event.*;
import java.net.*;
import java.io.*;
import java.util.*;

import java.applet.Applet;
import java.applet.AudioClip;
import java.util.Vector;
import java.util.Hashtable;
import java.util.Enumeration;
import java.net.URL;
import java.net.MalformedURLException;
import java.util.Vector ; // IuWFNgTCY̊gEksNX
// import CMAC ;

//---------------------
public class Critic {
	int max_dim;          // ԓ̓xNg̎
	int max_output_dim ;  // ʃxNg̗vf
	CMAC cmac ; // int div_i = 2, int tile_i =1
	double[] weight ; // 
	double discountRate ; //
	int criticID ;
	//-------------------RXgN^
	Critic() {
		max_dim = 1;
		cmac = new CMAC();
//		cmac.initAtEqualSpaces( max_dim, 2, 1 ); // e2A^COP
		cmac.initAtEqualSpaces( max_dim, 3, 1 ); // e3A^COP 2005.06.13@
		weight = new double[cmac.getNumOfOutput()];
		discountRate = 0.9; 
		criticID = 0;
	}
	Critic(int inputDim ) {
		max_dim = inputDim;
		cmac = new CMAC();
//		cmac.initAtEqualSpaces( max_dim, 2, 1 ); // e2A^COP
		cmac.initAtEqualSpaces( max_dim, 3, 1 ); // e3A^COP 2005.06.13 
		weight = new double[cmac.getNumOfOutput()];
		discountRate = 0.9; 
		criticID = 0;
	}
	Critic(int inputDim,  String str ) {
		max_dim = inputDim;
		cmac = new CMAC();
//		cmac.initAtEqualSpaces( max_dim, 2, 1 ); // e2A^COP
		cmac.initAtEqualSpaces( max_dim, 3, 1 ); // e3A^COP 2005.06.13 
		weight = new double[cmac.getNumOfOutput()];
		discountRate = 0.9; 
		criticID = 0;
		//-------
		if( str.startsWith( "Critic" ) ){
			StringTokenizer st = new StringTokenizer( str );
			String word ;
			while( st.hasMoreTokens() ){ 
				word = st.nextToken() ;
				if( word.equals( "criticID" ) ){ // 
					criticID = Integer.valueOf( st.nextToken() ).intValue();
				}else if( word.equals( "discountRate" ) ){ // 
					discountRate = Double.valueOf( st.nextToken() ).doubleValue();
				}else if( word.equals( "parameters" ) ){ // 
					for( int index = 0; index < cmac.getNumOfOutput(); index++ ){
						weight[index] = Double.valueOf( st.nextToken() ).doubleValue();
					}
				}
			}
		}
	}
	//----------------------
	public void setDiscountRate( double rate ){discountRate = rate ;}
	//-----------------------------ValuelXV@ԂlFTD_error
	public double backup( double[] currentState, 
	                      double[] nextState, 
	                      double reward, 
	                      double likelihoodratio, 
	                      double learningRate ){
		double[] currentFeature = new double[cmac.getNumOfOutput()];
		double[] currentFeaturePtr = cmac.getFeatureVector( currentState );
		double currentV = 0;
		for( int i= 0; i < cmac.getNumOfOutput(); i++ ){
			currentFeature[i] = currentFeaturePtr[i] ;
			currentV += (weight[i] * currentFeature[i]) ;
		}
		//---------------
		double[] nextFeaturePtr = cmac.getFeatureVector( nextState );
		double nextV = 0;
		for( int i= 0; i < cmac.getNumOfOutput(); i++ ){
			nextV += (weight[i] * nextFeaturePtr[i]) ;
		}
		//--------------
		double TD_error = (reward + (nextV * discountRate))*likelihoodratio - currentV ;
		double TD_errorTmp = TD_error * learningRate ;
		//--------------
		for( int i= 0; i < cmac.getNumOfOutput(); i++ ){
			weight[i] += (currentFeature[i] * TD_errorTmp) ;
		}
		return( TD_error ) ;
	}
	//---------------ێĂf[^𕶎ɂďo
	String getCriticString(){
		StringBuffer logStr = new StringBuffer("Critic ") ; 
		logStr.append("criticID " ) ;
		logStr.append( criticID ) ;
		logStr.append(" discountRate " ) ;
		logStr.append( discountRate ) ;
		logStr.append( " parameters "  ) ;
		for( int index = 0; index < cmac.getNumOfOutput(); index++ ){
			logStr.append( weight[index] ).append(" ")  ;
		}
		return( logStr.toString() );
	}





}


