//====================================================================
// State N Action N Importance SamplingΉmIXΖ@G[WFgilbg[NNCAgj
// VΉ
// iT[oj֐ڑčsw
// ԑJڂV܂͊wKf[^t@Cɕۑł
// 2003.05.15 by H.Kimura
// 2005.06.10 UDP, pause
//====================================================================

import java.awt.*;
import java.awt.event.*;
import java.net.*;
import java.io.*;
import java.util.*;

import java.applet.Applet;
import java.applet.AudioClip;
import java.util.Vector;
import java.util.Hashtable;
import java.util.Enumeration;
import java.net.URL;
import java.net.MalformedURLException;

// import NetAgentMTISnsna ;
//====================================================================
public class NetAgentMTISnsnaWindow extends Frame implements ActionListener {
	//-----
	NetAgentMTISnsna netAgent;
	//----------------------------------------------
	AgentMTISnsnaCanvas agentCanvas;
	FileDialog ParamLoadDialog;
	FileDialog ParamSaveDialog;
	FileDialog RewardLogFileDialog;
	FileDialog StateActRewardLogFileDialog;
	//----------
	static int portNumber ; // TCP-IP port number
	static String hostname ;
	//-----------------------------------------
	// RXgN^
	//-----------------------------------------
	NetAgentMTISnsnaWindow(){
		super( "NetAgentMTISnsnaWindow"); // Window Title
		setFont( new Font( "Courier", Font.PLAIN, 12 )) ;
		setSize( 400, 200 );
		//-------Menu, MenuBar
		Menu menu1 = new Menu("Files");
		MenuItem LoadParamFile = new MenuItem("LoadParamFile");
		MenuItem SaveParamFile = new MenuItem("SaveParamFile");
//		MenuItem SetRewardFile = new MenuItem("SetRewardFile");
//		MenuItem SetSARFile    = new MenuItem("SetState-Action-RewardFile");
		menu1.add( LoadParamFile );
		menu1.add( SaveParamFile );
//		menu1.add( SetRewardFile );
//		menu1.add( SetSARFile );
		//--------
		MenuItem Start     = new MenuItem("Start");
		MenuItem Pause     = new MenuItem("Pause");
		MenuItem Stop      = new MenuItem("Stop");
		MenuItem InitParam = new MenuItem("InitParam");
		MenuItem quit      = new MenuItem("quit");
		Menu menu2 = new Menu("System");
		menu2.add( Start );
		menu2.add( Pause );
		menu2.add( Stop );
		menu2.add( InitParam );
		menu2.add( quit );
		//---------
		MenuItem step10   = new MenuItem("10steps");
		MenuItem step50   = new MenuItem("50steps");
		MenuItem step100   = new MenuItem("100steps");
		MenuItem step200   = new MenuItem("200steps");
		MenuItem step500   = new MenuItem("500steps");
		MenuItem step1000  = new MenuItem("1000steps");
		MenuItem step2000  = new MenuItem("2000steps");
		MenuItem step3000  = new MenuItem("3000steps");
		MenuItem step4000  = new MenuItem("4000steps");
		MenuItem step5000  = new MenuItem("5000steps");
		MenuItem step10000 = new MenuItem("10000steps");
		MenuItem step20000 = new MenuItem("20000steps");
		MenuItem step50000 = new MenuItem("50000steps");
		Menu menu3 = new Menu("TimeSteps");
		menu3.add( step10 );
		menu3.add( step50 );
		menu3.add( step100 );
		menu3.add( step200 );
		menu3.add( step500 );
		menu3.add( step1000 );
		menu3.add( step2000 );
		menu3.add( step3000 );
		menu3.add( step4000 );
		menu3.add( step5000 );
		menu3.add( step10000 );
		menu3.add( step20000 );
		menu3.add( step50000 );
		//------------
		MenuItem SuspendLearning  = new MenuItem("SuspendLearning");
		MenuItem ResumeLearning   = new MenuItem("ResumeLearning");
		MenuItem SelectTask0      = new MenuItem("SelectTask0");
		MenuItem SelectTask1      = new MenuItem("SelectTask1");
		MenuItem SelectTask2      = new MenuItem("SelectTask2");
		MenuItem SelectTask3      = new MenuItem("SelectTask3");
		MenuItem EnableSimultaneousLearningMode  = new MenuItem("EnableSimultaneousLearningMode");
		MenuItem DisableSimultaneousLearningMode = new MenuItem("DisableSimultaneousLearningMode");
		Menu menu4 = new Menu("Func");
		menu4.add( SuspendLearning );
		menu4.add( ResumeLearning );
		menu4.add( SelectTask0 );
		menu4.add( SelectTask1 );
		menu4.add( SelectTask2 );
		menu4.add( SelectTask3 );
		menu4.add( EnableSimultaneousLearningMode );
		menu4.add( DisableSimultaneousLearningMode );
		//------------
		Menu menu5 = new Menu("PAUSE");
		menu5.add( Pause );
		//------------
		MenuBar mbar = new MenuBar();
		mbar.add( menu1 );
		mbar.add( menu2 );
		mbar.add( menu3 );
		mbar.add( menu4 );
		mbar.add( menu5 );
		setMenuBar( mbar );
		//-------
		LoadParamFile.addActionListener(this);
		SaveParamFile.addActionListener(this);
//		SetRewardFile.addActionListener(this);
//		SetSARFile.addActionListener(this);
		Start.addActionListener(this);
		Pause.addActionListener(this);
		Stop.addActionListener(this);
		InitParam.addActionListener(this);
		quit.addActionListener(this);
		step10.addActionListener(this);
		step50.addActionListener(this);
		step100.addActionListener(this);
		step200.addActionListener(this);
		step500.addActionListener(this);
		step1000.addActionListener(this);
		step2000.addActionListener(this);
		step3000.addActionListener(this);
		step4000.addActionListener(this);
		step5000.addActionListener(this);
		step10000.addActionListener(this);
		step20000.addActionListener(this);
		step50000.addActionListener(this);
		SuspendLearning.addActionListener(this);
		ResumeLearning.addActionListener(this);
		SelectTask0.addActionListener(this);
		SelectTask1.addActionListener(this);
		SelectTask2.addActionListener(this);
		SelectTask3.addActionListener(this);
		EnableSimultaneousLearningMode.addActionListener(this);
		DisableSimultaneousLearningMode.addActionListener(this);
		setVisible( true ); // show();
		//-------Agent display initialize
		agentCanvas = new AgentMTISnsnaCanvas();
		add( "Center", agentCanvas );
		agentCanvas.start();
		//--------Set FileDialog
		ParamLoadDialog = new FileDialog( this, "Parameter: Load" );
		ParamSaveDialog = new FileDialog( this, "Parameter: Save", FileDialog.SAVE );
		RewardLogFileDialog         = new FileDialog( this, "RewardLog: Save", FileDialog.SAVE );
		StateActRewardLogFileDialog = new FileDialog( this, "State-Act-RewardLog: Save", FileDialog.SAVE );
		//----------Agent
		netAgent = new NetAgentMTISnsna( hostname, portNumber, this ) ;
	}
	//---------------------------------------------------------------------
	// R}hvvgsꍇ̏
	//---------------------------------------------------------------------
	public static void main( String args[] ){
		//------
		if( args.length < 2 ){
			System.out.println("NetAgentGSRnsnaWindow <hostname> <TCP-IP port number> " );
			return ;
		}
		hostname = args[0].toString() ;
		portNumber = Integer.valueOf( args[1] ).intValue() ;
		System.out.println("hostname = " + hostname );
		System.out.println("TCP-IP port number = " + portNumber );
		//--------------
		NetAgentMTISnsnaWindow nawin = new NetAgentMTISnsnaWindow();
		nawin.setVisible( true ); // show();
		//----------------ftHgp[^t@Cǂݍ 2005.06.13
		if( args.length == 3 ){
			nawin.loadDefaultParameterFile( args[2] );
		}
	}
	//---------ftHgp[^t@Cǂݍ݂̂߂̃\bh 2005.06.13
	public void loadDefaultParameterFile( String filename ){
		netAgent.loadParam( filename );
	}
	//-----------------------------------------
	public void SetStepAndReward( int i, double rwd ){
		agentCanvas.SetStepAndReward( i, rwd );
	}
	//------------_CAO\ăt@Cw肵AwKp[^t@C֏o
	public void saveParameters(){
		ParamSaveDialog.show();
		if( ParamSaveDialog.getFile() !=  null ){
			netAgent.saveParam( ParamSaveDialog.getDirectory() + ParamSaveDialog.getFile() );
		}
	}
	//=======================================GUI EVENT 
	public void actionPerformed( ActionEvent e ){
		if( e.getActionCommand().equals("InitParam")){
			netAgent.initParam();
//		}else if( e.getActionCommand().equals("SetRewardFile")){
//			RewardLogFileDialog.show();
//			if( RewardLogFileDialog.getFile() == null ){return;}
//			netAgent.setRewardLogFilename( RewardLogFileDialog.getDirectory() + RewardLogFileDialog.getFile() );
//		}else if( e.getActionCommand().equals("SetState-Action-RewardFile")){
//			StateActRewardLogFileDialog.show();
//			if( StateActRewardLogFileDialog.getFile() ==  null ){ return ; }
//			netAgent.setStateActRewardLogFilename( StateActRewardLogFileDialog.getDirectory() + StateActRewardLogFileDialog.getFile() );
		}else if( e.getActionCommand().equals("LoadParamFile")){
			ParamLoadDialog.show();
			if( ParamLoadDialog.getFile() ==  null ){ return ; }
			netAgent.loadParam( ParamLoadDialog.getDirectory() + ParamLoadDialog.getFile() );
		}else if( e.getActionCommand().equals("SaveParamFile")){
			ParamSaveDialog.show();
			if( ParamSaveDialog.getFile() ==  null ){ return ; }
			netAgent.saveParam( ParamSaveDialog.getDirectory() + ParamSaveDialog.getFile() );
		}else if( e.getActionCommand().equals("Start")){
			RewardLogFileDialog.show();
			if( RewardLogFileDialog.getFile() != null ){
				netAgent.setRewardLogFilename( RewardLogFileDialog.getDirectory() + RewardLogFileDialog.getFile() );
			}
			StateActRewardLogFileDialog.show();
			if( StateActRewardLogFileDialog.getFile() !=  null ){
				netAgent.setStateActRewardLogFilename( StateActRewardLogFileDialog.getDirectory() + StateActRewardLogFileDialog.getFile() );
			}
			netAgent.start() ;
		}else if( e.getActionCommand().equals("Pause")){ // EwK̈ꎞ~
			netAgent.setPauseFlag();
			resumeDialog() ;
			netAgent.resetPauseFlag();
		}else if( e.getActionCommand().equals("Stop")){
			netAgent.setEpisodeSteps( 0 );
			// netAgent.shutupConnection();
		}else if( e.getActionCommand().equals("10steps")){
			netAgent.setEpisodeSteps( 10 ); 
		}else if( e.getActionCommand().equals("50steps")){
			netAgent.setEpisodeSteps( 50 ); 
		}else if( e.getActionCommand().equals("100steps")){
			netAgent.setEpisodeSteps( 100 ); 
		}else if( e.getActionCommand().equals("200steps")){
			netAgent.setEpisodeSteps( 200 ); 
		}else if( e.getActionCommand().equals("500steps")){
			netAgent.setEpisodeSteps( 500 ); 
		}else if( e.getActionCommand().equals("1000steps")){
			netAgent.setEpisodeSteps( 1000 );
		}else if( e.getActionCommand().equals("2000steps")){
			netAgent.setEpisodeSteps( 2000 );
		}else if( e.getActionCommand().equals("3000steps")){
			netAgent.setEpisodeSteps( 3000 );
		}else if( e.getActionCommand().equals("4000steps")){
			netAgent.setEpisodeSteps( 4000 );
		}else if( e.getActionCommand().equals("5000steps")){
			netAgent.setEpisodeSteps( 5000 );
		}else if( e.getActionCommand().equals("10000steps")){
			netAgent.setEpisodeSteps( 10000 );
		}else if( e.getActionCommand().equals("20000steps")){
			netAgent.setEpisodeSteps( 20000 );
		}else if( e.getActionCommand().equals("50000steps")){
			netAgent.setEpisodeSteps( 50000 );
		}else if( e.getActionCommand().equals("SuspendLearning")){
			System.out.println("SuspendLearning");
			netAgent.suspendLearning() ;
		}else if( e.getActionCommand().equals("ResumeLearning")){
			System.out.println("ResumeLearning");
			netAgent.resumeLearning() ;
		}else if( e.getActionCommand().equals("SelectTask0")){
			System.out.println("SelectTask0");
			netAgent.selectTask( 0 ) ;
		}else if( e.getActionCommand().equals("SelectTask1")){
			System.out.println("SelectTask1");
			netAgent.selectTask( 1 ) ;
		}else if( e.getActionCommand().equals("SelectTask2")){
			System.out.println("SelectTask2");
			netAgent.selectTask( 2 ) ;
		}else if( e.getActionCommand().equals("SelectTask3")){
			System.out.println("SelectTask3");
			netAgent.selectTask( 3 ) ;
		}else if( e.getActionCommand().equals("EnableSimultaneousLearningMode")){
			System.out.println("EnableSimultaneousLearningMode");
			netAgent.EnableSimultaneousLearningMode() ;
		}else if( e.getActionCommand().equals("DisableSimultaneousLearningMode")){
			System.out.println("DisableSimultaneousLearningMode");
			netAgent.DisableSimultaneousLearningMode() ;
		}else if( e.getActionCommand().equals("quit")){
			netAgent.setEpisodeSteps( 0 );
			System.exit( 0 );
		}
	}
	//---------------PauseꍇɓĊJ邽߂̃_CAO
	Dialog d ;
	public void resumeDialog(){
		d = new Dialog( this, true );
		d.setLayout(new GridLayout(2,1)) ;
		d.add( new Label("Push [ O K ] Button to Resume.") );
		Button b = new Button("[ O K ]") ;
		b.addActionListener( new ActionListener(){
			// {^ꂽ牽炩̏
			public void actionPerformed( ActionEvent e ){
				d.dispose() ; // _CAO̔j
			}
		});
		d.add( b );
		d.setResizable( true );
		d.setSize( 200, 200 );
		d.setTitle("---PAUSE---");
		d.show() ;
	}
}


//==================================================================

class AgentMTISnsnaCanvas extends Canvas implements Runnable{
	Thread runner; 
	int SleepTime;

	Font theFont ; //
	Image offscreenImage;
	Graphics offscreenGraphics;
	int cwidth, cheight ;
	int step;
	int reward;
	//-----------------------------------------
	AgentMTISnsnaCanvas(){
		//------
		SleepTime = 200;
		theFont = new Font("Courier", Font.PLAIN, 12 ); // "TimesRoman",Font.BOLD,16);
		cwidth = 16; cheight = 16;
	}
	//-----------------------------------------
	public void start(){
		if( runner == null ){
			runner = new Thread( this );
			runner.start();
		}
	}
	//-----------------------------------------
	public void run(){
		while( true ){
			repaint();
			try{ Thread.sleep( SleepTime ); }
			catch ( InterruptedException e ){ }
		}
	}
	//-----------------------------------------
	public void setSleepTime( int t ){ SleepTime = t;}
	//-----------------------------------------
	public void paint( Graphics g ){
		//-------offscreen
		if( (cwidth != this.getSize().width)||(cheight != this.getSize().height )){
			cwidth  = this.getSize().width;
			cheight = this.getSize().height;
			offscreenImage = createImage( this.getSize().width, this.getSize().height );
			offscreenGraphics = offscreenImage.getGraphics();
			offscreenGraphics.setFont( theFont );
		}
		//-----------offscreen to DC
		g.drawImage( offscreenImage, 0, 0, this );
		//----------
	}
	public void update( Graphics g ){
		paint( g );
	}
	//---------
	public void SetStepAndReward( int stepin, double rewardin ){
		step = stepin;
		reward = (int)rewardin ;
		int ai;
		int y0 = this.getSize().height / 2;
		int y1 = this.getSize().height ;
		ai = (step % this.getSize().width) ;
		if( ai== 0 ){
			offscreenGraphics.setColor( Color.black );
			offscreenGraphics.fillRect( 0, 0, this.getSize().width, this.getSize().height );
			offscreenGraphics.setColor( Color.gray );
			//--------
			offscreenGraphics.drawLine( 0, y0, this.getSize().width, y0 ); // center line
			offscreenGraphics.drawLine( 0, y0 + 10, this.getSize().width, y0 + 10 ); 
			offscreenGraphics.drawLine( 0, y0 + 20, this.getSize().width, y0 + 20 ); 
			offscreenGraphics.drawLine( 0, y0 + 30, this.getSize().width, y0 + 30 ); 
			offscreenGraphics.drawLine( 0, y0 + 40, this.getSize().width, y0 + 40 ); 
			offscreenGraphics.drawLine( 0, y0 + 50, this.getSize().width, y0 + 50 ); 
			offscreenGraphics.drawLine( 0, y0 - 10, this.getSize().width, y0 - 10 ); 
			offscreenGraphics.drawLine( 0, y0 - 20, this.getSize().width, y0 - 20 ); 
			offscreenGraphics.drawLine( 0, y0 - 30, this.getSize().width, y0 - 30 ); 
			offscreenGraphics.drawLine( 0, y0 - 40, this.getSize().width, y0 - 40 ); 
			offscreenGraphics.drawLine( 0, y0 - 50, this.getSize().width, y0 - 50 ); 
			//--------
			offscreenGraphics.setColor( Color.blue );
			for (int xi = 0 ; xi < this.getSize().width; xi += 50 ){
				offscreenGraphics.drawLine( xi, 0, xi, y1 ); 
			}
		}
		y1 = reward * 2 ;
		if( reward >= 0 ){
			offscreenGraphics.setColor( Color.green );
		}else{
			offscreenGraphics.setColor( Color.red );
		}
		offscreenGraphics.drawLine( ai, y0, ai, y0 - y1 );
		repaint() ;
	}

}



